__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain         PROTO   :DWORD,:DWORD,:DWORD,:DWORD
FillListView    PROTO   :DWORD
AddString       PROTO   :DWORD,:DWORD
DeleteString    PROTO   :DWORD

include \masm32\include\windows.inc
include \masm32\include\ecl.inc

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc


includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\ecl.lib

include \masm32\macros\macros.asm

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400
MAXFILE             equ     256
.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?

UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>

; +++ StaticEx related +++

UCSTR       StaticExClass,"STATICEX",0
hStx            dd          ?
iecx            INITEXTRACONTROLS   <sizeof iecx,IEC_STATIC_CLASS>
acst        ACSTRUCT    <?,?,offset MainWindowName>
UCSTR       FaceName,"Lucida Caligraphy",0

; +++ List View related +++

UCSTR       ListViewClass,"SysListView32",0
hListView   HWND        ?
lvc         LV_COLUMN   <>
lvi         LV_ITEM     <>
UCSTR       szFileName,"FileName",0
UCSTR       szAttributes,"Attributes",0

; +++ Other +++

rect            RECT        <>
UCSTR       szDrive,"c:\*",0
            dw      MAXFILE dup(0)  
UCSTR       szAttr,"----",0
hFile       dd          ?
w32fd       WIN32_FIND_DATA     <>
            
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  RegisterControls,hInstance,addr iecx
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPED\
                +WS_CLIPCHILDREN,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClientRect,hWnd,addr rect
            sub     rect.bottom,22
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,0,WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                        0,0,rect.right,rect.bottom,hWnd,0,0,0
            mov     hListView,eax
            mov     lvc.imask,LVCF_TEXT+LVCF_WIDTH+LVCF_FMT
            mov     lvc.fmt,LVCFMT_LEFT
            mov     lvc.pszText,offset szFileName
            mov     eax,rect.right
            shr     eax,1
            mov     lvc.lx,eax
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
            shr     lvc.lx,1
            mov     lvc.pszText,offset szAttributes
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
            invoke  FillListView,hWnd
            add     rect.bottom,2
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticExClass,0,WS_VISIBLE+WS_CHILD+STXS_BOTTOM,\
                        0,rect.bottom,rect.right,20,hWnd,0,0,0
            mov     hStx,eax 
            mov     acst.lpText,offset szDrive
            invoke  SendMessage,hStx,STXM_ADDCONTENT,0,addr acst 
            invoke  SendMessage,hListView,WM_GETFONT,0,0
            invoke  SendMessage,hStx,WM_SETFONT,eax,TRUE                                              
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
        
    .elseif uMsg==WM_NOTIFY
        mov     edi,lParam
        assume  edi:PTR NM_STXHEIGHTCHANGED
        .if     [edi].hdr.code==STXN_HEIGHTCHANGED
            invoke  GetClientRect,hWnd,addr rect
            mov     eax,[edi].Height
            sub     rect.bottom,eax
            invoke  MoveWindow,hListView,0,0,rect.right,rect.bottom,TRUE
        .endif
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

FillListView    PROC    hWnd:DWORD

    local   shfi:SHFILEINFO
    local   SET_HIML:DWORD
    
    mov     SET_HIML,TRUE
    mov     lvi.imask,LVIF_TEXT+LVIF_IMAGE
    mov     lvi.pszText,offset w32fd.cFileName
    mov     lvi.iItem,0
    mov     lvi.iSubItem,0
    invoke  FindFirstFile,addr szDrive,addr w32fd
    or      eax,eax
    jz      no_files
    mov     hFile,eax
compares:
    cmp     w32fd.cFileName,"."
    je      find_next
    invoke  AddString,addr szDrive,addr w32fd.cFileName
    invoke  SHGetFileInfo,addr szDrive,0,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX+\
                SHGFI_SMALLICON
    .if     SET_HIML==TRUE
        invoke  SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,eax
        mov     SET_HIML,FALSE
    .endif
    push    shfi.iIcon
    pop     lvi.iImage                                        
    invoke  SendMessage,hListView,LVM_INSERTITEM,0,addr lvi
    invoke  DeleteString,addr szDrive
    lea     edi,szAttr
    xor     ah,ah
    pushfd
    cld
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
    jz      no_dir
    mov     al,'d'
    jmp     next_1
no_dir:                           
    mov     ah,'-'
next_1:
    stosw   
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_ARCHIVE
    jz      no_arc
    mov     al,'a'
    jmp     next_2
no_arc:
    mov     al,'-'
next_2:
    stosw
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_SYSTEM
    jz      no_sys
    mov     al,'s'
    jmp     next_3
no_sys:
    mov     al,'-'
next_3:
    stosw
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_HIDDEN
    jz      no_hide
    mov     al,'h'
    jmp     end_attr
no_hide:
    mov     al,'-'
end_attr:
    stosw
    xor     eax,eax
    stosw
    popfd
    push    lvi.pszText
    mov     lvi.pszText,offset szAttr                 
    xor     lvi.imask,LVIF_IMAGE
    inc     lvi.iSubItem
    invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi
    dec     lvi.iSubItem
    or      lvi.imask,LVIF_IMAGE
    pop     lvi.pszText
    inc     lvi.iItem
find_next:
    invoke  FindNextFile,hFile,addr w32fd
    cmp     eax,0;INVALID_HANDLE_VALUE
    je      no_files
    jmp     compares
no_files:           
    ret

FillListView    endp

AddString   PROC    lpDestination:DWORD,lpSource:DWORD


    push    esi
    push    edi
    pushfd
    mov     esi,lpDestination
    cld
    xor     ah,ah
align_loop:
    lodsw
    cmp     al,'\'
    jne     align_loop
    mov     edi,esi
    mov     esi,lpSource
copy_loop:
    lodsw
    cmp     al,0
    je      end_it
    stosw
    jmp     copy_loop
end_it:
    stosw
    popfd
    pop     edi
    pop     esi
    ret

AddString   endp                    

DeleteString    PROC    lpString:DWORD

    push    esi
    push    edi
    pushfd
    mov     esi,lpString
    cld
loop_1:
    lodsw
    cmp     al,'\'
    jnz     loop_1
    mov     edi,esi
    xor     ax,ax
    stosw
    popfd
    pop     edi
    pop     esi
    ret

DeleteString    endp
end     start